#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "copy4xi.py">
#<abstract4xi abstract = "provides function copy4xi"/>
#<refer4xi reference = "sharedctypes.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
#


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'copy4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import weakref         
except:
    pass
try:                 # rare ones
    import ctypes         
except:
    pass 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>
     
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
from _new_value4xi import _new_value4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Constants                              
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
#<function4xi function = "copy4xi" usage = "
#   returns a pointer to object copy
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def copy4xi(obj):
    '''
    returns a pointer to object copy
    '''    
                
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/2) 
    # ---------------------------------------------------------------------------------------------   
    class2print = "copy4xi"
    method2print = "copy4xi"
    
    message2print = "{(Step 1/2a) started" + "; copy4xi-started: " + str(copy4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    message2print = "{(Step 1/2b) passed" + "; object-passed-to-copy4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/2) 
    # ---------------------------------------------------------------------------------------------   
         
    new_obj2xi = _new_value4xi(type(obj))

    message2print = "{(Step 2/2a) set" + "; new-obj2xi-set-by-copy4xi to: " + str(new_obj2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            

    ctypes.pointer(new_obj2xi)[0] = obj

    message2print = "{(Step 2/2b) set" + "; ctypes-pointer-set-by-copy4xi to: " + str(ctypes.pointer(new_obj2xi)[0])  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{(Step 2/2c) returning" + "; new_obj2xi-returning-by-copy4xi: " + str(new_obj2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
  
    return new_obj2xi
 #</function4xi> 
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of copy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

